'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createSelectorMapper;
function createSelectorMapper(selector) {
  for (var _len = arguments.length, rest = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    rest[_key - 1] = arguments[_key];
  }

  var listeners = Array.isArray(rest[0]) ? rest[0] : rest;

  if (!listeners.every(function (dep) {
    return typeof dep === 'function';
  })) {
    var dependencyTypes = listeners.map(function (dep) {
      return typeof dep;
    }).join(', ');
    throw new Error('SelectorMapper expect all listener to be functions, ' + `instead received the following types: [${dependencyTypes}]`);
  }

  var preResult = null;
  var selectorMapper = {
    selector,
    handlers: listeners
  };
  selectorMapper.getPreResult = function () {
    return preResult;
  };
  selectorMapper.updateResult = function (curResult) {
    preResult = curResult;
  };
  return selectorMapper;
}