'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isEmpty = require('lodash/fp/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _isEqual = require('lodash/fp/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (store) {
  for (var _len = arguments.length, mappers = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    mappers[_key - 1] = arguments[_key];
  }

  var selectorMappers = Array.isArray(mappers[0]) ? mappers[0] : mappers;
  var onReducerInvoke = function onReducerInvoke(sMappers) {
    return function () {
      sMappers.forEach(function (sMapper) {
        var preResult = sMapper.getPreResult();
        var nonPreResult = !preResult || (0, _isEmpty2.default)(preResult);
        var curResult = sMapper.selector(store.getState());
        if (nonPreResult && (!curResult || (0, _isEmpty2.default)(curResult))) {
          return;
        }
        if (nonPreResult || !(0, _isEqual2.default)(preResult, curResult)) {
          sMapper.handlers.forEach(function (handler) {
            handler.call(null, preResult, curResult);
          });
        }
        sMapper.updateResult(curResult);
      });
    };
  };
  store.subscribe(onReducerInvoke(selectorMappers));
};